package task2;

/**
 * Implement CumulativeMaxList using a Linked List.
 */
public class LinkedCumulativeMaxList implements CumulativeMaxList {
  protected final Node head;
  protected int numElements;
  /* Leave the fields as protected; our solution needs them! */

  /**
   * Construct a LinkedCumulativeMaxList.
   */
  public LinkedCumulativeMaxList() {
    head = new Node(0, null);
    numElements = 0;
  }

  @Override
  public void insertAt(int index, int value) {
    // TODO Implement me!
  }

  @Override
  public int get(int index) {
    Node node = find(index, head);
    return node.data;
  }

  @Override
  public int getMaxAt(int index) {
    Node node = find(index, head);
    return node.maxPrev.data;
  }

  @Override
  public int length() {
    return numElements;
  }

  // Walks k steps from curr
  // Pre: curr != null and k is a valid position
  protected Node find(int k, Node curr) {
    for (int i = 0; i < k; i++) {
      curr = curr.next;
    }
    return curr;
  }

  protected static class Node {
    int data;
    Node next;
    Node maxPrev;

    Node(int data, Node next) {
      this.data = data;
      this.next = next;
      maxPrev = this;
    }
  }
}
