package task3;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

public class BookCartTest {

  private BookCart cart;

  @BeforeEach
  void setUp() {
    cart = new BookCart();
  }


  @Test
  @DisplayName("Sort works for an arbitrary sequence of values in each pile")
  void randomPiles() {
    cart.add(1, new Book(1));
    cart.add(1, new Book(5));
    cart.add(1, new Book(3));
    cart.add(2, new Book(4));
    cart.add(2, new Book(6));
    cart.add(2, new Book(2));
    cart.add(2, new Book(0));

    cart.sort();

    int[] sortedCart = {0, 1, 2, 3, 4, 5, 6};
    int index = 0;
    for(Book book: cart) {
      assertEquals(sortedCart[index++], book.getNumPages());
    }
  }

}